#
# VPATH sets where to look for include files (besides the current
# directory)
#
VPATH=./inc:./obj:./src
#
# list of objects and include files
#
OBJECTS = hec_ana.o hec_ana_card.o hec_ana_evt.o hec_ana_ini.o \
          hec_ana_runh.o hec_ana_run_ini.o hec_ana_run_ter.o \
          hana_auto_cluster.o hana_auto_subcluster.o\
          hana_card.o hana_cluster.o hana_debug.o hana_fillvec.o \
          hana_fillvec_calc.o hana_gaufit.o hana_histogram.o \
          hana_hist_stat.o \
          hana_ini.o hana_minimize.o hana_open_noise.o hana_peakbin.o \
          hana_run_ini.o \
          hana_search_evt.o hana_search_run.o \
          hana_subclus.o hana_ter.o minfxn.o
#
INC     = hec_ana.inc hec_ana_card.inc hec_ana_evt.inc \
          hec_ana_paw.inc hec_ana_runh.inc \
          hana.inc hana_card.inc 
#
# user should not need to change anything below this point.
# CHANGE BELOW THIS POINT AT YOUR OWN RISK
#
#
# now figure out compiler and options for this platform
#
PLATFORM=$(shell uname)
#
# HP Unix
#
ifeq "$(PLATFORM)" "HP-UX"
  LIB = -L/cern/pro/lib -lpawlib -lgraflib -lgrafX11 \
        -lpacklib -lkernlib -lmathlib -lm -lX11
  COMP         = fort77  -c +ppu  -O2 -I./inc
#  COMP         = fort77  -C -c +ppu  -O2 -I./inc
  LINK         = fort77  +ppu -O2
#  LINK         = fort77  -C +ppu -O2
  LIB_NAME     = hec_adc.a
  OS_EXTENTION = 
endif
#
# compile 
#
ntuple_ana : $(OBJECTS)
	$(LINK) obj/*.o -o hec_ana $(LIB)
#
# define how to make an object from a .f file
#
.f.o :
	$(COMP) $<
	mv -f $*.o ./obj
#
# objects depend on the include files
#
$(OBJECTS) : $(INC)



