      subroutine hana_auto_cluster
     
c
c If the cluster size is set to a negative integer in the data card,
c  this routine will choose the cells with the highest mean energy
c  to make up the cluster.
c
      implicit none
c
      include'hec_ana.inc'
      include'hec_ana_runh.inc'      ! run header ntuple common
      include'hec_ana_evt.inc'       ! event ntuple common 
c
      include'hana.inc'
      include'hana_card.inc'
c
c local variables
c
      integer cl_size, i
c
c This option is turned on by setting the cluster size to a -ve value.
c
      if (clus_ic(0,irun) .ge. 0) return
c
c get the cluster size out
c
      cl_size = abs(clus_ic(0,irun))
c
c zero the array containing the ic numbers
c
      do i=0,maxn_ic
        clus_ic(i,irun) = 0
      enddo
c
c and refill the array with the correct ic numbers
c
      clus_ic(0,irun) = cl_size
      do i=1, min(cl_size,hec_cells_used)
        clus_ic(i,irun) = search_indx(i)
      enddo
c
c Print the result to log file
c
      print *,'hana_auto_cluster:*************************************'
      print *,'hana_auto_cluster:* Run# ', hec_runno
      print *,'hana_auto_cluster:* BEAM E ', hec_beame
      print *,'hana_auto_cluster:* Cluster replaced with new cluster'
      print *,'hana_auto_cluster:* found with hana_search.'
      print *,'hana_auto_cluster:* SIZE: ',cl_size
      print *,'hana_auto_cluster:* The new cluster uses cells:'
      print *,'hana_auto_cluster:* ',(clus_ic(i,irun), i = 1, cl_size)
      print *,'hana_auto_cluster:*************************************'

      return 
      end
