      subroutine hana_auto_subcluster
     
c
c If the subcluster size is to -1 in the data card,
c  this routine will use the cluster cells for the subcluster.
c
      implicit none
c
      include'hec_ana.inc'
      include'hec_ana_runh.inc'      ! run header ntuple common
      include'hec_ana_evt.inc'       ! event ntuple common 
c
      include'hana.inc'
      include'hana_card.inc'
c
c local variables
c
      integer cl_size, i
c
c This option is turned on by setting the cluster size to a -ve value.
c
      if (subclus_ic(0,irun) .ne. -1) return
c
c get the cluster size out
c
      cl_size = abs(clus_ic(0,irun))
c
c zero the array containing the ic numbers
c
      do i=0,maxn_ic
        subclus_ic(i,irun) = 0
      enddo
c
c and refill the array with the correct ic numbers
c
      subclus_ic(0,irun) = cl_size
      do i=1, min(cl_size,hec_cells_used)
        subclus_ic(i,irun) = clus_ic(i,irun)
      enddo
c
c Print the result to log file
c
      print *,'hana_auto_subcluster:**********************************'
      print *,'hana_auto_subcluster:* Run# ', hec_runno
      print *,'hana_auto_subcluster:* BEAM E ', hec_beame
      print *,'hana_auto_subcluster:* Subcluster size was set to -1'
      print *,'hana_auto_subcluster:* in the datacard.'
      print *,'hana_auto_subcluster:* Subcluster chosen to coincide'
      print *,'hana_auto_subcluster:* with Cluster.'
      print *,'hana_auto_subcluster:* SIZE: ',cl_size
      print *,'hana_auto_subcluster:* The new subcluster uses cells:'
      print *,'hana_auto_subcluster:* ',
     +        (subclus_ic(i,irun), i = 1, cl_size)
      print *,'hana_auto_subcluster:**********************************'

      return 
      end
