      subroutine hana_card
c
c Read hana specific variables from datacard
c
      implicit none
c
      include'hec_ana.inc'
      include'hana_card.inc'
c
c local variables
c 
      integer i, ir
      character*8 keyname, dep_name
      character*10 keyname2,keyname3      
c
c hana debugging flag
c
      call ffkey('debug',debug,  1,'mixe')
      debug = 0 
c
c Datacards relevant to DEPTH WEIGHTING AND MINIMIZATION
c
      call ffkey('alpha',alpha_global,  1,'mixe')
      alpha_global = 1. 
c
c NOTE: positive value= fix depth weight at this value
c       negative value= minimize depth weight starting at this value
c
      call vzero(depth_mod1,maxn_z)
      call ffkey('dwmod1',depth_mod1, maxn_z,'mixe')
      depth_mod1(1) = 1.      ! depth weights for module 1
      depth_mod1(2) = 1.
      depth_mod1(3) = 2.
c
c NOTE: for minimization the ratio between depth weights
c       for different modules will be held constant!
c
      call vzero(depth_mod2,maxn_z)
      call ffkey('dwmod2',depth_mod2, maxn_z,'mixe')
      depth_mod2(1) = 1.      ! depth weights for module 2
      depth_mod2(2) = 1.
      depth_mod2(3) = 2.
c
      call ffkey('minuitset',minuit_set,1,'mixe')
      minuit_set=1  !minuit minimization 1=migrad, 2=simplex, 0=off
c
c Depth weight on/off switches for minimization
c
      do i = 1, maxn_z
        write (dep_name,9) i
  9     format ('dw',i1,'on')
        call ffkey(dep_name,depth_switch(1,i),maxn_runs,'mixe')
        do ir = 1, maxn_runs
          if (i .eq. 1) depth_switch(ir,i) = 0
          if (i .ne. 1) depth_switch(ir,i) = 1
        enddo
      enddo
      call ffkey('alphaon',alpha_switch,maxn_runs,'mixe')
      do i = 1, maxn_runs
        alpha_switch(i) = 1
      enddo
c
c control of iterative minimization
c
      call ffkey('minthr',mean_thresh,2,'mixe')
      mean_thresh = 10000.
      sigma_thresh = 10000.
c
c Datacards relevant to TRIGGERS
c
      call ffkey('trigon',trig_switch, 1,'mixe')
      trig_switch = 1     !turn on/off (1/0) trigger requirement
c
      call ffkey('trig',trig_set,     5,'mixe')
      trig_set(1)=1                 !physics
      trig_set(2)=2                 !electron
      trig_set(3)=0                 !muon
      trig_set(4)=2                 !pion
      trig_set(5)=0                 !random
c                                   0/1/2 ==> no/yes/any
c
c Datacards relevant to CLUSTERING
c
      do ir = 1, maxn_runs
        write (keyname,11) ir
 11     format('klus',i3.3)
        call ffkey(keyname,clus_ic(0,ir),maxn_ic+1,'mixe')
        call vzero(clus_ic,(maxn_ic+1)*maxn_runs)
      enddo
c
c Datacards relevant to noise calculation
c
      call ffkey('noise',noisetype,     2,'mixe')
      noisetype=1                 !physics
      noise_run=1111
c
c Datacards relevant to SUB CLUSTERING
c
      do ir = 1, maxn_runs
        write (keyname2,15) ir
 15     format('subhits',i3.3)
        call ffkey(keyname2,subclus_hits(ir),1,'mixe')
        call vzero(subclus_hits,maxn_runs)
      enddo
c      
      do ir = 1, maxn_runs
        write (keyname3,17) ir
 17     format('subclus',i3.3)
        call ffkey(keyname3,subclus_ic(0,ir),maxn_ic+1,'mixe')
        call vzero(subclus_ic,(maxn_ic+1)*maxn_runs)
      enddo
c
c Datacards relevant to Gaussian fitting
c
      call ffkey('gaufit',gaufit_switch,    1,'mixe')
      gaufit_switch = 1          !turn on/off gaussian fitting (1/0)
c
      call ffkey('nbins',nbins,maxn_runs,'mixe')
      do i=1,maxn_runs
        nbins(i) = 100                !number of bins in histogram
      enddo
c
      call ffkey('plotcut',energy_plot_switch,1,'mixe')
      energy_plot_switch = 0     !turn on/off energy plot cuts (1/0)
c
c This cut sets the range in which to plot histograms - the range is
c  in the units the final energy is plot in! It may be set differently
c  for each run.
      call ffkey('plotlo',energy_plot_lo,maxn_runs,'mixe')
      do i=1,maxn_runs
        energy_plot_lo(i) = 0.            
      enddo
      call ffkey('plothi',energy_plot_hi,maxn_runs,'mixe')
      do i=1,maxn_runs
        energy_plot_hi(i) = 200.        
      enddo
c
c This cut replaces the hi/lo sigma cut if set
c  if it is +ve, it replaces sigma cut for minimization and gaufit
c  if it is -ve, it replaces sigma cut, only if the hardcut encompasses
c   a smaller range than the sigma cut
c
      call ffkey('hardcut',hardcut_switch,1,'mixe')
      hardcut_switch = 0     !turn on/off hard cut 
c                             for gaufit & minimization (1/0)
      call ffkey('hardlo',hardcut_lo,maxn_runs,'mixe')
      do i=1,maxn_runs
        hardcut_lo(i) = 0.            
      enddo
      call ffkey('hardhi',hardcut_hi,maxn_runs,'mixe')
      do i=1,maxn_runs
        hardcut_hi(i) = 0.            
      enddo
c
      call ffkey('sigcut',sig_cut_lo,   2,'mixe')
      sig_cut_lo = 3.                   ! sigma range to fit in
      sig_cut_hi = 3.
c
c A different sigma cut may also be set for individual runs.
c  if sig_rcut_lo(run_no)=0., then sig_rcut_lo(run_no)=sig_cut_lo
      call ffkey('sigrlo',sig_rcut_lo,maxn_runs,'mixe')
      do i=1,maxn_runs
        sig_rcut_lo(i) = 0.            ! sigma range to fit in
      enddo
      call ffkey('sigrhi',sig_rcut_hi,maxn_runs,'mixe')
      do i=1,maxn_runs
        sig_rcut_hi(i) = 0.            ! sigma range to fit in
      enddo
c
      return
      end






