      subroutine hana_cluster
c
c sum energies in clusters of cells
c
      implicit none
c
      include'hec_ana.inc'
      include'hec_ana_runh.inc'      ! run header ntuple common
      include'hec_ana_evt.inc'       ! event ntuple common 
c
      include'hana.inc'
      include'hana_card.inc'
c
c local variables
c
      integer i, ic   !loops
      integer iz, imod
      logical subcut_flag
c
c
c Only do analysis for events which satisfy trigger requirements set
c in the datacard. Means we need to count the number of events that 
c pass this requirement
c
      if ( ( (hec_trig(1).eq.trig_set(1) .or. trig_set(1).eq.2) .and.
     +       (hec_trig(2).eq.trig_set(2) .or. trig_set(2).eq.2) .and.
     +       (hec_trig(3).eq.trig_set(3) .or. trig_set(3).eq.2) .and.
     +       (hec_trig(4).eq.trig_set(4) .or. trig_set(4).eq.2) .and.
     +       (hec_trig(5).eq.trig_set(5) .or. trig_set(5).eq.2) )
     +     .or. trig_switch .eq. 0 ) then
c
c If a "Hot Subcluster" is defined in the datacard, then call 
c  subclustering routine
c
        if (subclus_hits(irun) .ge. 1) then
          subcut_flag = .false.
          call hana_subclus(subcut_flag)
        else
          subcut_flag = .true.
        endif   
c 
c make decision to keep event or not
c
        if (subcut_flag) then
          ievt_count = ievt_count + 1
c
c Do the actual clustering
c
          do ic = 1, clus_ic(0,irun)
            do i = 1, hec_cells_used
              if ( hec_ic(i) .eq. clus_ic(ic,irun) ) then
                iz = hec_iz(i)
                if (hec_iphi(i) .eq. 1 .or. hec_iphi(i) .eq. 2) imod=2 
                if (hec_iphi(i) .eq. 3 .or. hec_iphi(i) .eq. 4) imod=1
                cluster(ievt_count,iz,imod) = 
     +            cluster(ievt_count,iz,imod) + hec_signal(i) 
              endif  ! if the cell is in the cluster
            enddo    ! do i = 1, hec_cells_used
          enddo      ! do ic = 1, clus_sz
c
        endif        ! if (subcut_flag)
      endif          ! if (triggers)
c
      return
      end

