      subroutine hana_fillvec
      implicit none
c
c system commons
c
      include'hec_ana.inc'           ! general parameter common
      include'hec_ana_card.inc'      ! general datacard common
      include'hec_ana_runh.inc'      ! run header ntuple common
c
      include'hana.inc'
      include'hana_card.inc'
c
      integer i
      real resol, resol_err, resol_sub, resol_sub_err
c
c Convention: all real numbers will be printed as e11.5e2
c                     this allows 1 place for a negative sign,
c                     5 figures after the decimal place, and
c                     2 figures for the exponential.
c
c
c Open output file before writing first run.
c
      if (irun .eq. 1) open(unit=33,file='hec_out_vector.dat')

      if (irun .eq. 1) write(33,9) 'nruns',nruns
 9    format (a10,1x,i4.4)

      write(33,*)'C        Run_no, Run_id_no, Part_type, x(cm), y(cm)' 
      write(33,11)'runheader', irun,  run_list(irun), hec_parttype,
     +           hec_cryox, hec_tabley
 11   format (a10,1x,i4.4,1x,i4.4,1x,i4.4,1x,e11.5e2,1x,e11.5e2)

      write(33,*)'C     E_beam, <E_rec>, error, SIGMA_rec, error, ',
     +           'Noise, error'
      write(33,13)'recon ',hec_beame, signal_mean, signal_mean_error,
     +           signal_sigma, signal_sigma_error, noise, noise_error
 13   format (a10,7(1x,e11.5e2))

c
c Call Routine to calculate resolutions and errors
c
      call hana_fillvec_calc(resol, resol_err, 
     +                       resol_sub, resol_sub_err)
      write(33,*)'C     Mu/Sig, error, Mu/Sig_NSub, error'
      write(33,15)'resol ',resol, resol_err, resol_sub, resol_sub_err
 15   format (a10,4(1x,e11.5e2))

      write(33,*)'C     Clus_sz, Cell_list... '
      write(33,16)'klus ', clus_ic(0,irun)
 16   format (a10,1x,i4.4,NN)
 17   format (1x,i4.4,NN)
      do i=1,clus_ic(0,irun)
        write(33,17) clus_ic(i,irun)
      enddo
      write (33,18)
 18   format (NL)

      write(33,*)'C        Subclus_hits Subclus_sz, Cell_list... '
      write(33,19)'subclus ', subclus_hits(irun), subclus_ic(0,irun)
 19   format (a10,1x,i4.4,1x,i4.4,NN)
      do i=1,subclus_ic(0,irun)
        write(33,17) subclus_ic(i,irun)
      enddo
      write (33,18)

      write(33,*)'C (HARDWR:) DW1(1), DW1(2),  ',
     +           'DW2(1), DW2(2), DW3(1), DW3(2) '
      write(33,21)'dwhardwr ',depth_mod1(1), depth_mod2(1),
     +    depth_mod1(2), depth_mod2(2), depth_mod1(3), depth_mod2(3)
 21   format (a10,6(1x,e11.5e2))

      write(33,*)'C (SOFTWR:) Alpha, ',
     +           'DW1_min, DW2_min, DW3_min, MIN_option, MIN_success'
      write(33,23)'dwsoftwr ', alpha_min, ( depth_min(i), i=1,maxn_z ),
     +                        minuit_set, minuit_error_flag
 23   format (a10,4(1x,e11.5e2),1x,i4.4,1x,i4.4)

c
c Close output file after writing last run.
c
      if (irun .eq. nruns) close(unit=33)
      return
      end
