      subroutine hana_gaufit(id)
c
c Fits histogram #id to a gaussian curve iteratively.
c
      implicit none
c
c common blocks
c
      include'hec_ana.inc'
      include'hec_ana_runh.inc'      ! run header ntuple common
      include'hec_ana_evt.inc'       ! event ntuple common 
c
      include'hana.inc'
      include'hana_card.inc'
c
c local variables
c
      integer id                !histogram id #, input 
      integer oldmeanbin,newmeanbin,iteration !iteration variables
      integer peakbin, tmp_bin   !bin # of maximum in histogram
      real peak
      real mean,sigma
      integer IQUEST(100)       !common req'd for HFITHN
      real par(3),sigpar(3),chi2 !parameters for HFITHN
c
      real hstati
      external hstati
c
c common block used with HFITHN
c
      common /QUEST/IQUEST
c
c If individual sigma cuts for each run haven't been set in the 
c  data card, then set them to the global datacard values:
c
      if (sig_rcut_lo(irun) .eq. 0.) sig_rcut_lo(irun)= sig_cut_lo
      if (sig_rcut_hi(irun) .eq. 0.) sig_rcut_hi(irun)= sig_cut_hi
c
c Get statistics from the current run using HBOOK routine hstati
c
      mean = hstati(id,1,' ',0)
      sigma = hstati(id,2,' ',0)
      call hana_peakbin(id,peakbin,peak)
ccc
      print *,'mean,sigma ',mean,sigma
      print *,'id,peakbin,peak ',id,peakbin,peak
ccc
      par(1) = peak
      call HIX (id,peakbin,par(2))
      par(3) = sigma
ccc
      print *,'par1,2,3 ',par(1),par(2),par(3)
ccc
c
c Set fit range to be peakbin +- Xsigma
c
      call HXI (id,par(2)-(sig_rcut_lo(irun)*sigma),IQUEST(11))
      call HXI (id,par(2)+(sig_rcut_hi(irun)*sigma),IQUEST(12))
      if (hardcut_switch .eq. 1) then
        call HXI (id,abs(hardcut_lo(irun)),tmp_bin)
        if (IQUEST(11) .lt. tmp_bin .or. hardcut_lo(irun) .ge. 0)
     +         IQUEST(11) = tmp_bin
        call HXI (id,abs(hardcut_hi(irun)),tmp_bin)
        if (IQUEST(12) .lt. tmp_bin .or. hardcut_hi(irun) .ge. 0) 
     +         IQUEST(12) = tmp_bin
      endif
c
c FIT!
c
      call HFITHN(id,'g','RE',3,par,par,par,par,sigpar,chi2)
c
c reiterate fitting from -Xsigma ==> +Xsigma
c get channel number for mean-(lowsig)sigma and save it as IQUEST(11)
c get channel number for mean+(hisig)sigma and save it as IQUEST(12)
c 
c iterate until the bin of the mean does not shift 
c  with another iteration
c  set maximum number of iterations to 5
c
      oldmeanbin = -1
      iteration = 0
      do while (oldmeanbin .ne. newmeanbin .and. iteration .le. 5)
        iteration = iteration + 1
        call HXI (id,par(2),oldmeanbin)
        call HXI (id,par(2)-sig_rcut_lo(irun)*abs(par(3)),IQUEST(11))
        call HXI (id,par(2)+sig_rcut_hi(irun)*abs(par(3)),IQUEST(12))
        if (hardcut_switch .eq. 1) then
          call HXI (id,abs(hardcut_lo(irun)),tmp_bin)
          if (IQUEST(11) .lt. tmp_bin .or. hardcut_lo(irun) .ge. 0)
     +         IQUEST(11) = tmp_bin
          call HXI (id,abs(hardcut_hi(irun)),tmp_bin)
          if (IQUEST(12) .lt. tmp_bin .or. hardcut_hi(irun) .ge. 0) 
     +         IQUEST(12) = tmp_bin
        endif
        call HFITHN(id,'g','RE',3,par,par,par,par,sigpar,chi2)
        call HXI (id,par(2),newmeanbin)
      enddo                     !do while (oldmeanbin .ne. newmeanbin)
c
c Save the results in the common block!
c
      gau_mean = par(2)
      gau_mean_err = sigpar(2)
      gau_sigma = par(3)
      gau_sigma_err = sigpar(3)
      print *,'hana_gaufit: gau_mean, gau_mean_err,',
     +        ' gau_sigma, gau_sigma_err',
     +    gau_mean, gau_mean_err, gau_sigma, gau_sigma_err
c
      return
      end


