      subroutine hana_hist_stat(hmax,hmin,mean,sigma,sigma_error)
c
c Loops over all events and finds the max,min,mean and sigma
c  of the signal
c
c
      implicit none
c
      include'hec_ana.inc'
      include'hec_ana_runh.inc'      ! run header ntuple common
      include'hec_ana_evt.inc'       ! event ntuple common 
c
      include'hana.inc'
      include'hana_card.inc'
c
c local variables
c

      integer i,id
      real energy, av_energy, av2_energy
      real hmax,hmin,mean,sigma,sigma_error

      av_energy = 0.
      av2_energy = 0.
      hmin = 1.E+20    ! this is a very large real #
      hmax = -1.E+20
      mean = 0.
      sigma = 0.

      do i=1, ievt_count
        energy = 0.
        do id=1, maxn_z
          energy = energy + 
     +      (alpha_min*( abs(depth_min(id)*depth_mod1(id))
     +                      *cluster(i,id,1) ))
          energy = energy + 
     +      (alpha_min*( abs(depth_min(id)*depth_mod2(id))
     +                      *cluster(i,id,2) ))
        enddo
        if (energy .ge. hmax) hmax = energy
        if (energy .le. hmin) hmin = energy
        av_energy = av_energy + energy
        av2_energy = av2_energy + (energy**2)
      enddo  ! do over events

      av_energy = av_energy / real(ievt_count)
      av2_energy = av2_energy / real(ievt_count)
      mean = av_energy
      sigma = sqrt( av2_energy - (av_energy**2))
      sigma_error = sigma / sqrt( 2.*real(ievt_count) )

      return
      end

