      subroutine hana_histogram(baseid)
c
      implicit none
c
      include'hec_ana.inc'
      include'hec_ana_runh.inc'      ! run header ntuple common
      include'hec_ana_evt.inc'       ! event ntuple common 
c
      include'hana.inc'
      include'hana_card.inc'
c
c local variables
c
      integer i,id,baseid
      integer hid
      real energy
      real hmax,hmin,mean,sigma,sigma_error  !used to find max/min
      character*45 hist_name
c
      logical first
      data first /.true./
      save first
ccc
      print *,'irun is ',irun
ccc
c
c fin dmin/max values for histo ranges, etc.
c
      call hana_hist_stat(hmax,hmin,mean,sigma,sigma_error)
ccc
      print *,'hmin,hmax are ',hmin,hmax
ccc
c
c Determine the range of energy to plot
c
      if (energy_plot_switch .eq. 1 .and. baseid .lt. 3000) then
        hmax = energy_plot_hi(irun)
        hmin = energy_plot_lo(irun)
      endif
c
c DELETE all histograms in memory!
c
      call hdelet(0)
c
c need different histogram number for each run
c
      hid = baseid + irun
c
c Fill relevant histograms
c
      write(hist_name,8) hec_runno, hec_beame
 8    format('Clustered Energy, Run ',I4.4,' E_o=',F5.1)
ccc
      print *,'hid,histname,nbins,irun,hmin,hmax',
     +        hid,hist_name,irun,hmin,hmax 
ccc
      call HBOOK1 (hid,hist_name,nbins(irun),hmin,hmax,0.)
c
c fill histograms once per event after adding up the energy over
c  all depths and modules.
c
      do i=1, ievt_count
        energy = 0.
        do id=1, maxn_z
          energy = energy + 
     +      (alpha_min*( abs(depth_min(id)*depth_mod1(id))
     +                          *cluster(i,id,1) ))
          energy = energy + 
     +      (alpha_min*( abs(depth_min(id)*depth_mod2(id))
     +                          *cluster(i,id,2) ))
        enddo
        call HFILL (hid,energy,0.,1.)
      enddo  ! do over events
c
      if (gaufit_switch .eq. 1) call hana_gaufit(hid)
c
c For the case of the noise runs we wish to get out the statistical
c  mean and sigma... which we already have from the hana_hist_stat routine:
c
      stat_mean = mean
      stat_sigma = sigma
      stat_sigma_error = sigma_error
c
      return
      end

        
