      subroutine hana_search_run
c
c Sorts and writes out the results of the search to the log file.
c
      implicit none
c
      include'hec_ana.inc'
      include'hec_ana_runh.inc'      ! run header ntuple common
      include'hec_ana_evt.inc'       ! event ntuple common 
c
      include'hana.inc'
      include'hana_card.inc'
c
c local variables
c
      integer i
      real search_mean(maxn_ic), search_sigma(maxn_ic)
      real search_percent(maxn_ic)
      real tot_mean, tot_sigma
      real percent_sum
c
c zero arrays
c
      call vzero(search_indx,maxn_ic)
      call vzero(search_mean,maxn_ic)
      call vzero(search_sigma,maxn_ic)
      call vzero(search_percent,maxn_ic)
      percent_sum = 0.
c
c calculate the total mean signal deposited in all cells
c  and its sigma
c
      tot_mean = search_tot_sum/real(search_tot_count)
      tot_sigma = sqrt( (search_tot_sumsq/real(search_tot_count)) -
     +                  (search_tot_sum/real(search_tot_count))**2 )
c
c Calculate mean signal deposited in each cell, its sigma, and also
c  as a percentage of the total signal
c
      do i = 1, hec_adc_max
        search_mean(i) = search_sum(i)/real(search_count(i))
        search_sigma(i) =sqrt( (search_sumsq(i)/real(search_count(i)))
     +                   - (search_sum(i)/real(search_count(i)))**2 )
        search_percent(i) = 100.*search_mean(i)/tot_mean
      enddo
c
c Create an array index=search_indx which is the 
c  ascending order of the cells
c
      call sortzv(search_percent,search_indx,maxn_ic,1,1,0)
c
c print out the results to log file
c
      print *,'hana_search_run:***************************************'
      write (*,11) hec_runno
 11   format( ' hana_search_run:* Search Results: RUN# ',I5.5)
      write (*,12) hec_beame
 12   format( ' hana_search_run:*               BEAM E ',F6.1)
      print *,'hana_search_run:***************************************'
      print *,'hana_search_run: <total_energy> = ', tot_mean
      print *,'hana_search_run: RMS_tot_energy = ', tot_sigma
      print *,'hana_search_run:***************************************'
c
c loop over ic's
c
      write(*,13)
 13   format (' hana_search_run: ic   rank  %_of_tot    %_sum',
     +        '    <signal>       sigma')
      do i = 1, maxn_ic
c
c need to keep a running total of the percent energy
c
        percent_sum = percent_sum + search_percent(search_indx(i))

        write(*,15) search_indx(i), i, search_percent(search_indx(i)),
     +              percent_sum, search_mean(search_indx(i)),
     +              search_sigma(search_indx(i))
 15     format ( ' hana_search_run: ',i3.3,3x,i3,3x,
     +           f7.3,2x,f7.3,2x,f10.1,2x,f10.1)
      enddo
      print *,'hana_search_run:***************************************'

      return
      end
