      subroutine minfxn(npar,grad,fval,xval,iflag,futil)
c
c minimized function for depth weights
c
      implicit none
c
      include'hec_ana.inc'
      include'hec_ana_runh.inc'      ! run header ntuple common
      include'hec_ana_evt.inc'       ! event ntuple common 
c
      include'hana.inc'
      include'hana_card.inc'
c
c local variables
c
      real*8 fval,grad,xval
      dimension grad(*),xval(*)
      integer iflag,npar
      character*10 futil
      real m_locut,m_hicut
c
      integer i, iz
      real*8 energy,uwenergy
c
c loop over events
c
      fval = 0.
      do i = 1, ievt_count
        energy = 0.
        uwenergy = 0.
        do iz = 1, maxn_z
c
c calculate unweighted energy for sigma cut
c
          uwenergy = uwenergy + 
     +      (abs(alpha_global)*( abs(depth_mod1(iz))
     +                          *cluster(i,iz,1) ))
          uwenergy = uwenergy + 
     +      (abs(alpha_global)*( abs(depth_mod2(iz))
     +                          *cluster(i,iz,2) ))
c
          energy = energy + 
     +      xval(1)*xval(iz+1)*
     +      ( dble( abs(depth_mod1(iz))*cluster(i,iz,1) +
     +              abs(depth_mod2(iz))*cluster(i,iz,2)  ) )
        enddo
c
c All events included in the minimization must fall within sigma cut
c  limits
c
        m_hicut = dble(gau_mean+abs(sig_rcut_hi(irun)*gau_sigma))
        m_locut = dble(gau_mean-abs(sig_rcut_lo(irun)*gau_sigma))
        if (hardcut_switch .eq. 1) then
          m_hicut = hardcut_hi(irun)
          m_locut = hardcut_lo(irun)
        endif
        if ( uwenergy .ge. m_locut .and. uwenergy .le. m_hicut) then
          fval = fval + ( (energy-dble(hec_beame))**2 )
        endif
      enddo
c
ccc      print *,'minfxn.f: energy_rec,fval,alpha,DW1,DW2,... ',energy,
ccc     +           fval,xval(1),xval(2),xval(3),xval(4)
ccc      print *,'minfxn.f: m_hicut, m_locut',m_hicut, m_locut
c
      return 
      end










